"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TgContext = exports.TgKeyboard = exports.TgMessageBuilder = exports.TgUpdateHandler = exports.TgPolling = exports.TgApi = exports.Tg = void 0;
const Api_1 = require("./src/Api");
Object.defineProperty(exports, "TgApi", { enumerable: true, get: function () { return Api_1.Api; } });
const transports_1 = require("./src/transports");
Object.defineProperty(exports, "TgPolling", { enumerable: true, get: function () { return transports_1.Polling; } });
const UpdateHandler_1 = require("./src/UpdateHandler");
Object.defineProperty(exports, "TgUpdateHandler", { enumerable: true, get: function () { return UpdateHandler_1.UpdateHandler; } });
const MessageBuilder_1 = require("./src/MessageBuilder");
Object.defineProperty(exports, "TgMessageBuilder", { enumerable: true, get: function () { return MessageBuilder_1.MessageBuilder; } });
const Keyboard = require("./src/KeyboardBuilder");
exports.TgKeyboard = Keyboard;
const Context = require("./src/contexts");
exports.TgContext = Context;
class Tg {
    constructor(token) {
        this.token = token;
        this.api = new Api_1.Api(this.token);
        this.updates = new UpdateHandler_1.UpdateHandler(this.api);
        this.createKeyboard = () => new Keyboard.KeyboardBuilder();
        this.createInlineKeyboard = () => new Keyboard.InlineKeyboardBuilder();
    }
    startPolling() {
        this.eventTransport = new transports_1.Polling(this.api);
        return this.eventTransport.start(this.updates);
    }
}
exports.Tg = Tg;
