"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Message = void 0;
const attachments_1 = require("./attachments");
const Chat_1 = require("./Chat");
const Entity_1 = require("./Entity");
const User_1 = require("./User");
class Message extends Entity_1.Entity {
    constructor() {
        var _a, _b;
        super(...arguments);
        this.id = this.get("message_id");
        this.date = this.get("date");
        this.sender = this.construct("from", User_1.User);
        this.chat = this.construct("chat", Chat_1.Chat);
        this.repliedMessage = this.construct("reply_to_message", Message);
        this.text = (_a = this.get("text")) !== null && _a !== void 0 ? _a : this.get("caption");
        this.entities = (_b = this.get("entities")) !== null && _b !== void 0 ? _b : this.get("caption_entities");
        // attachments
        this.audio = this.construct("audio", attachments_1.Audio);
        this.voice = this.construct("voice", attachments_1.Voice);
        this.video = this.construct("video", attachments_1.Video);
        this.videoNote = this.construct("video_note", attachments_1.VideoNote);
        this.document = this.construct("document", attachments_1.Document);
        this.photo = this.get("photo")
            ? this.get("photo").map(photo => new attachments_1.Photo(photo))
            : [];
    }
    get hasAttachments() {
        return [
            this.audio,
            this.video,
            this.voice,
            this.videoNote,
            this.document,
            this.photo.length
                ? this.photo
                : null
        ].some(attachment => attachment != null);
    }
}
exports.Message = Message;
