"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Polling = void 0;
const debug = require("debug");
const EventTransport_1 = require("./EventTransport");
class Polling extends EventTransport_1.EventTransport {
    constructor() {
        super(...arguments);
        this.log = debug("tg-io:polling");
    }
    async start(handler) {
        if (this.state === EventTransport_1.EventTransportState.Working)
            return;
        this.log("started");
        let offset = null;
        this.state = EventTransport_1.EventTransportState.Working;
        while (this.state === EventTransport_1.EventTransportState.Working) {
            let updates = await this.api.callMethod("getUpdates", (offset === null ? {} : { offset }));
            for (let update of updates.result) {
                await handler.handle(update);
                offset = update.update_id + 1;
            }
        }
    }
    stop() {
        if (this.state !== EventTransport_1.EventTransportState.Working)
            return;
        this.log("stopped");
        this.state = EventTransport_1.EventTransportState.Stopped;
    }
}
exports.Polling = Polling;
